__gnu_debug::_Safe_local_iterator_base Class Reference

`#include <safe_unordered_base.h>`

Inheritance diagram for __gnu_debug::_Safe_local_iterator_base:
[legend]

## Public Member Functions

bool | _M_attached_to (const _Safe_sequence_base *__seq) const
bool | _M_can_compare (const _Safe_iterator_base &__x) const noexcept
void | _M_invalidate ()
void | _M_reset () noexcept
const _Safe_unordered_container_base * | _M_safe_container () const noexcept
bool | _M_singular () const noexcept
void | _M_unlink () noexcept

## Public Attributes

_Safe_iterator_base * | _M_next
_Safe_iterator_base * | _M_prior
const _Safe_sequence_base * | _M_sequence
unsigned int | _M_version

## Protected Member Functions

| _Safe_local_iterator_base ()
| _Safe_local_iterator_base (const _Safe_local_iterator_base &__x, bool __constant)
| _Safe_local_iterator_base (const _Safe_unordered_container_base *__seq, bool __constant)
void | _M_attach (const _Safe_sequence_base *__seq, bool __constant)
void | _M_attach (const _Safe_unordered_container_base *__cont, bool __constant)
void | _M_attach_single (const _Safe_sequence_base *__seq, bool __constant) noexcept
void | _M_attach_single (const _Safe_unordered_container_base *__cont, bool __constant) noexcept
void | _M_detach ()
void | _M_detach_single () noexcept
__gnu_cxx::__mutex & | _M_get_mutex () noexcept

## Detailed Description

Basic functionality for a safe iterator.

The _Safe_local_iterator_base base class implements the functionality of a safe local iterator that is not specific to a particular iterator type. It contains a pointer back to the container it references along with iterator version information and pointers to form a doubly-linked list of local iterators referenced by the container.

This class must not perform any operations that can throw an exception, or the exception guarantees of derived iterators will be broken.

Definition at line 50 of file safe_unordered_base.h.

## Constructor & Destructor Documentation

## _Safe_local_iterator_base() [1/3]

__gnu_debug::_Safe_local_iterator_base::_Safe_local_iterator_base | ( |  | ) |

inline protected

Initializes the iterator and makes it singular.

Definition at line 58 of file safe_unordered_base.h.

Referenced by _Safe_local_iterator_base().

## _Safe_local_iterator_base() [2/3]

__gnu_debug::_Safe_local_iterator_base::_Safe_local_iterator_base | ( | const _Safe_unordered_container_base * | __seq,
|  | bool | __constant )

inline protected

Initialize the iterator to reference the container pointed to by `__seq`. `__constant` is true when we are initializing a constant local iterator, and false if it is a mutable local iterator. Note that `__seq` may be NULL, in which case the iterator will be singular. Otherwise, the iterator will reference `__seq` and be nonsingular.

Definition at line 68 of file safe_unordered_base.h.

References _M_attach().

## _Safe_local_iterator_base() [3/3]

__gnu_debug::_Safe_local_iterator_base::_Safe_local_iterator_base | ( | const _Safe_local_iterator_base & | __x,
|  | bool | __constant )

inline protected

Initializes the iterator to reference the same container that `__x` does. `__constant` is true if this is a constant iterator, and false if it is mutable.

Definition at line 75 of file safe_unordered_base.h.

References _Safe_local_iterator_base(), and _M_attach().

## ~_Safe_local_iterator_base()

__gnu_debug::_Safe_local_iterator_base::~_Safe_local_iterator_base | ( |  | ) |

inline protected

Definition at line 79 of file safe_unordered_base.h.

## Member Function Documentation

## _M_attach() [1/2]

void __gnu_debug::_Safe_iterator_base::_M_attach | ( | const _Safe_sequence_base * | __seq,
|  | bool | __constant )

protected inherited

Attaches this iterator to the given sequence, detaching it from whatever sequence it was attached to originally. If the new sequence is the NULL pointer, the iterator is left unattached.

References _M_attach().

Referenced by _Safe_iterator_base(), _Safe_iterator_base(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_attach(), and _M_attach().

## _M_attach() [2/2]

void __gnu_debug::_Safe_local_iterator_base::_M_attach | ( | const _Safe_unordered_container_base * | __cont,
|  | bool | __constant )

protected

Attaches this iterator to the given container, detaching it from whatever container it was attached to originally. If the new container is the NULL pointer, the iterator is left unattached.

Referenced by _Safe_local_iterator_base(), _Safe_local_iterator_base(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_attach().

## _M_attach_single() [1/2]

void __gnu_debug::_Safe_iterator_base::_M_attach_single | ( | const _Safe_sequence_base * | __seq,
|  | bool | __constant )

protected noexcept inherited

Likewise, but not thread-safe.

References _M_attach_single().

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_attach_single(), and _M_attach_single().

## _M_attach_single() [2/2]

void __gnu_debug::_Safe_local_iterator_base::_M_attach_single | ( | const _Safe_unordered_container_base * | __cont,
|  | bool | __constant )

protected noexcept

Likewise, but not thread-safe.

Referenced by __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_attach_single().

## _M_attached_to()

bool __gnu_debug::_Safe_iterator_base::_M_attached_to | ( | const _Safe_sequence_base * | __seq | ) | const

inline inherited

Determines if we are attached to the given sequence.

Definition at line 161 of file safe_base.h.

References _M_attached_to(), and _M_sequence.

Referenced by _M_attached_to().

## _M_can_compare()

bool __gnu_debug::_Safe_iterator_base::_M_can_compare | ( | const _Safe_iterator_base & | __x | ) | const

noexcept inherited

Can we compare this iterator to the given iterator `__x`? Returns true if both iterators are nonsingular and reference the same sequence.

References _Safe_iterator_base(), and _M_can_compare().

Referenced by _M_can_compare().

## _M_detach()

void __gnu_debug::_Safe_local_iterator_base::_M_detach | ( |  | ) |

protected

Detach the iterator for whatever container it is attached to, if any.

Referenced by __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_Safe_local_iterator(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=().

## _M_detach_single()

void __gnu_debug::_Safe_local_iterator_base::_M_detach_single | ( |  | ) |

protected noexcept

Likewise, but not thread-safe.

## _M_get_mutex()

__gnu_cxx::__mutex & __gnu_debug::_Safe_iterator_base::_M_get_mutex | ( |  | ) |

protected noexcept inherited

For use in _Safe_iterator.

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator++(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator++(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=().

## _M_invalidate()

void __gnu_debug::_Safe_iterator_base::_M_invalidate | ( |  | ) |

inline inherited

Invalidate the iterator, making it singular.

Definition at line 176 of file safe_base.h.

References _M_invalidate(), and _M_version.

Referenced by _M_invalidate().

## _M_reset()

void __gnu_debug::_Safe_iterator_base::_M_reset | ( |  | ) |

noexcept inherited

Reset all member variables

## _M_safe_container()

const _Safe_unordered_container_base * __gnu_debug::_Safe_local_iterator_base::_M_safe_container | ( |  | ) | const

inline noexcept

Definition at line 219 of file safe_unordered_base.h.

## _M_singular()

bool __gnu_debug::_Safe_iterator_base::_M_singular | ( |  | ) | const

noexcept inherited

Is this iterator singular?

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_Safe_local_iterator(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_Safe_local_iterator(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_Safe_local_iterator(), __gnu_debug::__check_singular_aux(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_dereferenceable(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_dereferenceable(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_incrementable(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_incrementable(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=().

## _M_unlink()

void __gnu_debug::_Safe_iterator_base::_M_unlink | ( |  | ) |

inline noexcept inherited

Unlink itself

Definition at line 185 of file safe_base.h.

References _M_next, _M_prior, and _M_unlink().

Referenced by _M_unlink().

## Member Data Documentation

## _M_next

_Safe_iterator_base* __gnu_debug::_Safe_iterator_base::_M_next

inherited

Pointer to the next iterator in the sequence's list of iterators. Only valid when _M_sequence != NULL.

Definition at line 76 of file safe_base.h.

Referenced by _Safe_iterator_base(), _Safe_iterator_base(), _Safe_iterator_base(), __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if(), and _M_unlink().

## _M_prior

_Safe_iterator_base* __gnu_debug::_Safe_iterator_base::_M_prior

inherited

Pointer to the previous iterator in the sequence's list of iterators. Only valid when _M_sequence != NULL.

Definition at line 72 of file safe_base.h.

Referenced by _Safe_iterator_base(), _Safe_iterator_base(), _Safe_iterator_base(), __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if(), and _M_unlink().

## _M_sequence

const _Safe_sequence_base* __gnu_debug::_Safe_iterator_base::_M_sequence

inherited

The sequence this iterator references; may be NULL to indicate a singular iterator. Stored as pointer-to-const because sequence could be declared as const.

Definition at line 59 of file safe_base.h.

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), _Safe_iterator_base(), _Safe_iterator_base(), _Safe_iterator_base(), _M_attached_to(), __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=().

## _M_version

unsigned int __gnu_debug::_Safe_iterator_base::_M_version

inherited

The version number of this iterator. The sentinel value 0 is used to indicate an invalidated iterator (i.e., one that is singular because of an operation on the container). This version number must equal the version number in the sequence referenced by _M_sequence for the iterator to be non-singular.

Definition at line 68 of file safe_base.h.

Referenced by _Safe_iterator_base(), _Safe_iterator_base(), _Safe_iterator_base(), _M_invalidate(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

The documentation for this class was generated from the following file:

- safe_unordered_base.h